/*
 * PMSpy Module for ShadowIRCd 3.5.x
 *
 * This is proof of concept. You shouldn't *actually* use this code.
 * This code works against ShadowCVS > 20041123_0. It's based on in3crypt's
 * module for 2.4, which did not work so well.
 *
 * Basically, to enable pm spying, add the following to your general { }
 * block, or add a general { } block with this in it:
 *
 *    spy_channel = "#pmspy";
 *
 * Then you should be good to go!
 */
#include "stdinc.h"
#include "handlers.h"
#include "client.h"
#include "ircd.h"
#include "numeric.h"
#include "common.h"
#include "s_misc.h"
#include "s_conf.h"
#include "s_serv.h"
#include "send.h"
#include "msg.h"
#include "parse.h"
#include "modules.h"
#include "channel.h"
#include "channel_mode.h"
#include "irc_string.h"
#include "hash.h"
#include "packet.h"
#include "hook.h"
#include "newconf.h"

int show_privmsg(struct hook_privmsg_data *);
static void conf_target_channel(void *);
char *target_channel;

void
_modinit(void)
{
	hook_add_hook("client_message_preprocess", (hookfn *)show_privmsg);
	add_conf_item("general", "spy_channel", CF_QSTRING, conf_target_channel);
}

void
_moddeinit(void)
{
	hook_del_hook("client_message_preprocess", (hookfn *)show_privmsg);
	del_conf_item("general", "spy_channel");
}

const char *_version = "nenolod, version 3";

static void
conf_target_channel(void *data)
{
	DupString(target_channel, data);
}

int
show_privmsg(struct hook_privmsg_data *data)
{
	struct Channel *acptr;

	if (!target_channel)
		return 0;

	acptr = get_or_create_channel(&me, target_channel, NULL);

	sendto_channel_local(ALL_MEMBERS, acptr, ":%s!%s@%s PRIVMSG %s :[to %s] %s",
			 data->from->name, data->from->username, GET_CLIENT_HOST(data->from),
			 TARGET_CHANNEL, data->to->name, data->text);

	return 0;
}
